<?php
namespace TekNutri\Services;

use Doctrine\DBAL\Connection;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\SMTP;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;

chdir(__DIR__);

/** @var \Zeedhi\Framework\DependencyInjection\InstanceManager $instanceManager */
require_once '../bootstrap.php';
$sincronizacao = $instanceManager->getService('sincronizacao');
$connection = $instanceManager->getService('connection');

$dataSource = file_get_contents('../gen/datasources/contratoAtivoUrl.json');
$sql = json_decode($dataSource, true)["contratoAtivoUrl"]["query"];
$result = $connection->fetchAll($sql, []);
/*
$result = array(
    array(
        "NRORG" => "2258",
        "NRORGINT" => "2258",
        "NMORGANIZACAO" => "PREFEITURA MUNICIPAL DE ROLANDIA",
        "URLINTEGRAORG" => "http://willersantos1.zeedhi.com//workfolder/tecfood-integra/",
        "IDSITREMESSA" => "N",
        "DTULTSINC" => "29/06/2021 17:12:33"    
    )
);
*/

$dataSet = new DataSource\DataSet("",$result);
$request = new Request\DataSet($dataSet,"","","");
$response = new Response();

date_default_timezone_set('America/Sao_Paulo');
$date = date('d/m/Y H:i');

$sincronizacao->sincronizar($request,$response);
$organizacoes = $response->getDataSets()[0]->getRows();

$configFile = file_get_contents('../config/config.json');
$config = json_decode($configFile, true);

$address = explode(';',$config["emailsSincronizacao"]);
//organizacoes com erro

if(!empty($organizacoes)){
    $msg = "Sincronização finalizada, porém ocorreram os seguintes erro(s) na(s) organização(ões):<br/>";
    
    foreach($organizacoes as $org){
        $nmorg = $org['NMORG'];
        $error = $org['ERROR'];
        $msg .= "<br/>-".$nmorg."<br/><i>".$error."</i><br/>";
        if(strpos($error, "PREPARA AMBIENTE - ERROR") !== false) $msg .= "<b>Obs.: enquanto a preparação do ambiente não for realizada, a sincronização não acontecerá para a mesma.</b>";
    }
    $subject = "Sincronização Automática ".$date; 
    $formatedMessage = "<html style='padding: 0px; margin: 0px;'><head> <style>table{border: 1px solid #cccaca; width: 500px; background-color: #dbdbdb;}p, pre, td{font-family: Verdana, Geneva, sans-serif !important; color: #000000; font-size: 14px; line-height: 18px;}.description{padding: 20px; padding-bottom: 10px; padding-top: 4px;}.title{padding: 20px; padding-top: 10px; padding-bottom: 0px;}.title div{font-weight: bold; width: 100%; border-bottom: 1px solid #000;}.footer p{color: #00528C; font-weight: 300; margin-bottom: 40px;}.header .logo{padding-bottom: 10px;}.logo img{width: 200px; margin-left: 20px; margin-top: 15px;}</style> <link rel='stylesheet' href='/zimbra/css/msgview.css?v=120105100505'> </head><body class='MsgBody MsgBody-html' style='margin: 0px; height: auto;'> <center> <table cellpadding='0' cellspacing='0'> <tbody> <tr class='header'> <td class='logo'> <p><img dfsrc='https://www.teknisa.com/imagens/logo-teknisa.png' src='https://www.teknisa.com/imagens/logo-teknisa.png'></p></td></tr><tr> <td class='title'> <div>". $subject ."</div></td></tr><tr> <td class='description'>". $msg ."</td></tr></tbody> </table> </center></body></html>";
   
    $paramsSMTP =  array(
        'host' => $config["smtpHost"],
        'username' => $config["smtpUserName"],
        'password' => $config["smtpPassword"]
    );

    $SMTP = new SMTP($paramsSMTP);
    
    $SMTP->setSubject($subject);
    $SMTP->setFrom("no-reply@teknisa.com");
    $SMTP->setFromName("SAC TekNutri");
    $SMTP->sendMail($formatedMessage, $address);
    
}

echo('Processo Finalizado!');
