/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ETAPAPROD                                                */
/* Tabela : ETAPAPROD                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 21/04/2007 - Ronald Reis                                                   */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_ETAPAPROD
BEFORE INSERT OR UPDATE OR DELETE
ON ETAPAPROD FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUETPR := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDETAPAPROD,0) <> NVL(:NEW.CDETAPAPROD,0)) OR
         (NVL(:OLD.NMETAPAPROD,0) <> NVL(:NEW.NMETAPAPROD,0)) OR
         (NVL(:OLD.TXOBETAPROD,0) <> NVL(:NEW.TXOBETAPROD,0)) THEN
         :NEW.DTULTATUETPR := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('ETAPAPROD', '', 'CDETAPAPROD='||:OLD.CDETAPAPROD||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE ETAPAPROD MODIFY DTULTATUETPR DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_ETAPAPROD','4.11.134'); END;
/
