/* Sistemas Integrados TEKNISA
Nome: 0003_SESSTPS_SES_TRAB_IMPOSTO_ENTRADA.SQL

@C:\Win_520\Sql\End_Conv\SqlServer\Clientes\Ses\0003_SESSTPS_SES_TRAB_IMPOSTO_ENTRADA.SQL

DESCRIO:
ROTINA PARA GERAR IMPOSTOS NAS TABELAS DE TRABALHO

CRIAO:
02/05/2011 - JEFFERSON DE MELO GOUVEA

*/

IF EXISTS (SELECT *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE
              O.NAME = 'SES_TRAB_IMPOSTO_ENTRADA' AND
              TYPE = 'P' 			      AND
              U.UID = O.UID            AND
              U.NAME = USER)

DROP PROCEDURE SES_TRAB_IMPOSTO_ENTRADA
GO

CREATE PROCEDURE SES_TRAB_IMPOSTO_ENTRADA @P_CDFILIAL   VARCHAR(04),
	                        				   @P_NRLANCTONF VARCHAR(20),
                                 			@P_NRLANCESTQ VARCHAR(20),
			                                 @P_VRNOTAFISC VARCHAR(21) OUTPUT
AS
   DECLARE @V_INCITEMP     VARCHAR(14);
   DECLARE @V_ALIQTEMP     VARCHAR(14);
   DECLARE @V_CSTTEMP      VARCHAR(14);
   DECLARE @V_PAISORIG     VARCHAR(04);
   DECLARE @V_ESTAORIG     VARCHAR(02);
   DECLARE @V_MUNIORIG     VARCHAR(04);
   DECLARE @V_PAISDEST     VARCHAR(04);
   DECLARE @V_ESTADEST     VARCHAR(02);
   DECLARE @V_MUNIDEST     VARCHAR(04);
   DECLARE @V_IDTRIMPSTII  VARCHAR(01);
   DECLARE @V_CDFORNECED   VARCHAR(21);
   DECLARE @V_CDGRUPOFISC  VARCHAR(03);
   DECLARE @V_IDINTEREST   VARCHAR(01);

   DECLARE @V_VRNOTAFISC   DOUBLE PRECISION;
   DECLARE @V_LIQUIITEM    DOUBLE PRECISION;
   DECLARE @V_MINBCPROD    DOUBLE PRECISION;
   DECLARE @V_NRALIQTEMP   DOUBLE PRECISION;
   DECLARE @V_PARDEDTMP    DOUBLE PRECISION;
   DECLARE @V_PREDBCTMP    DOUBLE PRECISION;
   DECLARE @V_ALIQUTMP     DOUBLE PRECISION;
   DECLARE @V_IMPOSTOIT    DOUBLE PRECISION;
   DECLARE @V_ALIQINFO     DOUBLE PRECISION;
   DECLARE @V_IMPOSINFO    DOUBLE PRECISION;
   DECLARE @V_VRIMPOSTOST  DOUBLE PRECISION;
   DECLARE @V_TAXABASECALC DOUBLE PRECISION;
   DECLARE @V_TAXAALIQUOTA DOUBLE PRECISION;
   DECLARE @V_TAXAALIQINFO DOUBLE PRECISION;
   DECLARE @V_TAXABCSUBSTR DOUBLE PRECISION;
   DECLARE @V_BASECALCIT   DOUBLE PRECISION;
   DECLARE @V_PBCSUBTRIB   DOUBLE PRECISION;
   DECLARE @V_LIQUIDOPROD  DOUBLE PRECISION;

   /*VARIAVEIS DO CURSOR C_NOTAIMP*/
   DECLARE @V_NF_CDFILIAL			VARCHAR(04);
   DECLARE @V_NF_NRLANCTONF		VARCHAR(20);
	DECLARE @V_NF_CDEMPRESA			VARCHAR(02);
   DECLARE @V_NF_CDINSCESTA		VARCHAR(16);
   DECLARE @V_NF_CDFORNECED		VARCHAR(21);
   DECLARE @V_NF_CDFILIRECE		VARCHAR(04);
   DECLARE @V_NF_DTENTRSAID		DATE;
   DECLARE @V_NF_CDSERIEENTR		VARCHAR(05);
   DECLARE @V_NF_NRINSJURNF		VARCHAR(20);
   DECLARE @V_NF_IDORIGDESTNF		VARCHAR(01);
   DECLARE @V_NF_CDTIPOOPER		VARCHAR(02);
   DECLARE @V_NF_CDFILIEMIT		VARCHAR(04);
   DECLARE @V_NF_NRNOTAFISC		VARCHAR(20);

   /*VARIAVEIS DO CURSOR C_ITEM*/
   DECLARE @V_IT_CDARVPROD			VARCHAR(20);
   DECLARE @V_IT_VRDESCITEM		DOUBLE PRECISION;
   DECLARE @V_IT_VRTOTAITEM		DOUBLE PRECISION;
   DECLARE @V_IT_NRSEQITPROD		VARCHAR(04);
   DECLARE @V_IT_CDPRODUTO			VARCHAR(10);

   /*VARIAVEIS DO CURSOR C_INCIDENCIA*/
   DECLARE @V_ID_CDIMPOTEMP		VARCHAR(02);
   DECLARE @V_ID_CDFISCTEMP		VARCHAR(01);
   DECLARE @V_ID_IDTRATIMPTMP		VARCHAR(01);
   DECLARE @V_ID_IDCONSISTENT		VARCHAR(01);
   DECLARE @V_ID_IDUTMUNIORIG		VARCHAR(01);
   DECLARE @V_ID_IDIMPORECUP		VARCHAR(01);
   DECLARE @V_ID_IDPREIMPENTR		VARCHAR(01);
   DECLARE @V_ID_IDORGARRECAD		VARCHAR(01);
   
   /*VARIAVEIS DO CURSOR C_IMPOSNFTOT*/
   DECLARE @V_INT_CDIMPOSTO		VARCHAR(02);
   DECLARE @V_INT_VRIMPOSTOIT		DOUBLE PRECISION;
   DECLARE @V_INT_VRBASECALCIT	DOUBLE PRECISION;

BEGIN
   DECLARE C_NOTAIMP CURSOR FOR SELECT DISTINCT NF.CDFILIAL, NF.NRLANCTONF, NF.CDEMPRESA,
   											NF.CDINSCESTA, NF.CDFORNECED, NF.CDFILIRECE,
                                  	NF.DTENTRSAID, NF.CDSERIEENTR, NF.NRINSJURNF,
                                  	NF.IDORIGDESTNF, NF.CDTIPOOPER, NF.CDFILIEMIT,
                                  	NF.NRNOTAFISC
   								  	 FROM NOTAFISCAL NF
                              WHERE NF.CDFILIAL   = @P_CDFILIAL
                   				  AND NF.NRLANCTONF = @P_NRLANCTONF;

   OPEN C_NOTAIMP;
   FETCH NEXT FROM C_NOTAIMP INTO  @V_NF_CDFILIAL,   @V_NF_NRLANCTONF,   @V_NF_CDEMPRESA,  @V_NF_CDINSCESTA,
   									  @V_NF_CDFORNECED, @V_NF_CDFILIRECE,   @V_NF_DTENTRSAID, @V_NF_CDSERIEENTR,
   									  @V_NF_NRINSJURNF, @V_NF_IDORIGDESTNF, @V_NF_CDTIPOOPER, @V_NF_CDFILIEMIT,
                           	  @V_NF_NRNOTAFISC;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      EXEC CONSULTA_GRUPOFISCAL @V_NF_IDORIGDESTNF, @V_NF_CDFORNECED, '','E', @V_NF_CDTIPOOPER, @V_CDGRUPOFISC;


      DECLARE C_ITEM CURSOR FOR SELECT  R.CDARVPROD, I.VRDESCITEM, I.VRTOTAITEM,
             				                I.NRSEQITPROD, I.CDPRODUTO
				                      FROM  ITEMPRODUTO I, PRODUTO R
                    				   WHERE  I.CDFILIAL   = @V_NF_CDFILIAL
				                       AND  I.NRLANCTONF = @V_NF_NRLANCTONF
            				           AND  I.CDPRODUTO  = R.CDPRODUTO;

      OPEN C_ITEM;
   	FETCH NEXT FROM C_ITEM INTO  @V_IT_CDARVPROD,   @V_IT_VRDESCITEM,   @V_IT_VRTOTAITEM,  @V_IT_NRSEQITPROD,
   										  @V_IT_CDPRODUTO;

	   WHILE (@@FETCH_STATUS = 0) BEGIN
         SET @V_INCITEMP = @V_NF_CDFILIAL+@V_NF_NRLANCTONF;
         SET @V_ALIQTEMP = @V_NF_CDFILIAL+@V_NF_NRLANCTONF;
         SET @V_CSTTEMP  = @V_NF_CDFILIAL+@V_NF_NRLANCTONF;

         IF @V_NF_IDORIGDESTNF = 'L' BEGIN
            SELECT @V_PAISORIG = MAX(CDPAIS), @V_ESTAORIG = MAX(SGESTADO), @V_MUNIORIG = MAX(CDMUNICIPIO)
              FROM ENDEFILI
             WHERE (CDFILIAL     = @V_NF_CDFILIRECE) AND
                   (IDTPENDEFILI = 'P');

            SELECT @V_CDFORNECED = MAX(CDFORNOPELOG)
            FROM FILIAL
            WHERE CDFILIAL = @V_NF_CDFILIEMIT;
         END
         ELSE BEGIN
            SELECT @V_PAISORIG = MAX(CDPAIS), @V_ESTAORIG = MAX(SGESTADO), @V_MUNIORIG = MAX(CDMUNICIPIO)
              FROM ENDEFORN
             WHERE (CDFORNECED   = @V_NF_CDFORNECED) AND
                   (IDTPENDEFORN = 'P');

         	SET @V_CDFORNECED = @V_NF_CDFORNECED;
         END;

         SELECT @V_PAISDEST = MAX(CDPAIS), @V_ESTADEST = MAX(SGESTADO), @V_MUNIDEST = MAX(CDMUNICIPIO)
           FROM INSCRESTAD
          WHERE (CDEMPRESA  = @V_NF_CDEMPRESA) AND
                (CDINSCESTA = @V_NF_CDINSCESTA);
         SET @V_LIQUIDOPROD = @V_IT_VRTOTAITEM - @V_IT_VRDESCITEM;

         EXEC CALCULO_MINBCPRODUTO @V_NF_CDEMPRESA, @V_NF_CDTIPOOPER, @V_NF_CDINSCESTA, 'E', @V_PAISORIG, @V_ESTAORIG,
         								  @V_IT_CDPRODUTO, NULL, @V_NF_DTENTRSAID, @V_NF_CDFILIAL, @V_NF_NRLANCTONF,
                                   @V_IT_NRSEQITPROD, @V_MINBCPROD;

         IF @V_MINBCPROD = 0 BEGIN
            SET @V_LIQUIITEM = @V_IT_VRTOTAITEM - @V_IT_VRDESCITEM;
         END ELSE BEGIN
           	SET @V_LIQUIITEM = @V_MINBCPROD - @V_IT_VRDESCITEM;
         END;
         SET @V_IDINTEREST = 'N';
         IF (@V_PAISDEST = @V_PAISORIG) AND (@V_ESTADEST <> @V_ESTAORIG) BEGIN
            SET @V_IDINTEREST = 'S';
         END;

         EXEC CONSULTA_CST 'E', @V_NF_CDEMPRESA, @V_IT_CDARVPROD, @V_NF_CDINSCESTA, @V_NF_CDTIPOOPER, @V_NF_CDFILIAL, @V_NF_NRLANCTONF, @V_CDGRUPOFISC;
         EXEC CONSULTA_INCIDENCIA 'E', @V_NF_CDEMPRESA, @V_IT_CDARVPROD, @V_NF_CDINSCESTA, @V_NF_CDTIPOOPER, @V_NF_CDFILIAL,
         								 @V_NF_NRLANCTONF, @V_CDGRUPOFISC, NULL;
         DECLARE C_INCIDENCIA CURSOR FOR SELECT CDIMPOTEMP, MAX(CDFISCTEMP) AS CDFISCTEMP,
                       				               MAX(IDTRATIMPTMP) AS IDTRATIMPTMP,
                                  				   MAX(IDCONSISTENT) AS IDCONSISTENT, MAX(ISNULL(IDUTMUNIORIG, 'N')) AS
                                    			   IDUTMUNIORIG,
                                     				MAX(IDIMPORECUP)  AS IDIMPORECUP,
                                     				MAX(ISNULL(IDPREIMPENTR, 'N')) AS IDPREIMPENTR,
                                     				MAX(IDORGARRECAD) AS IDORGARRECAD
                               				 FROM INCITEMP IT, IMPOSTO IP
                               				WHERE (IT.NRINCITEMP = @V_INCITEMP)
                                            AND (IP.CDIMPOSTO = IT.CDIMPOTEMP)
                                            AND (IP.IDPRODNOTA = 'P')
                               			GROUP BY CDIMPOTEMP;

	      OPEN C_INCIDENCIA;
   		FETCH NEXT FROM C_INCIDENCIA INTO  @V_ID_CDIMPOTEMP,   @V_ID_CDFISCTEMP,	  @V_ID_IDTRATIMPTMP,	@V_ID_IDCONSISTENT,
         											  @V_ID_IDUTMUNIORIG, @V_ID_IDIMPORECUP,	  @V_ID_IDPREIMPENTR,	@V_ID_IDORGARRECAD;

	   	WHILE (@@FETCH_STATUS = 0) BEGIN
         	IF @V_ID_IDUTMUNIORIG = 'D' BEGIN
               /* CONSIDERA O MUNICIPIO DE DESTINO */
               EXEC CONSULTA_ALIQUOTA @V_ID_CDIMPOTEMP, 'E', @V_NF_CDEMPRESA, @V_IT_CDARVPROD, @V_NF_CDINSCESTA, @V_PAISORIG,
               							  @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIDEST, @V_LIQUIITEM, @V_NF_DTENTRSAID,
                                      @V_NF_CDFILIAL, @V_NF_NRLANCTONF, @V_CDGRUPOFISC;
            END ELSE
               BEGIN
               /* CONSIDERA O MUNICIPIO DE ORIGEM */
               EXEC CONSULTA_ALIQUOTA @V_ID_CDIMPOTEMP, 'E', @V_NF_CDEMPRESA, @V_IT_CDARVPROD, @V_NF_CDINSCESTA, @V_PAISORIG,
                 	  		              @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIORIG, @V_LIQUIITEM, @V_NF_DTENTRSAID,
                    	    		        @V_NF_CDFILIAL, @V_NF_NRLANCTONF, @V_CDGRUPOFISC;
            END;
            SET @V_NRALIQTEMP  = 0;
            SET @V_PARDEDTMP   = 0;
            SET @V_PREDBCTMP   = 0;
            SET @V_ALIQUTMP    = 0;
            SET @V_IMPOSTOIT   = 0;
            SET @V_ALIQINFO    = 0;
            SET @V_IMPOSINFO   = 0;
            SET @V_VRIMPOSTOST = 0;

            SELECT @V_NRALIQTEMP = ISNULL(MAX(NRALIQTEMP),0), @V_PARDEDTMP   = ISNULL(MAX(VRPARDEDTMP),0),
                   @V_PREDBCTMP  = ISNULL(MAX(VRPREDBCTMP),0), @V_ALIQUTMP   = ISNULL(MAX(VRALIQUTMP),0),
                   @V_PBCSUBTRIB = ISNULL(MAX(VRPBCSTTMP),0), @V_IDTRIMPSTII = ISNULL(MAX(IDTRIMPSTTMP), '0')
 	           FROM ALIQTEMP
             WHERE (NRALIQTEMP = @V_ALIQTEMP);

            SET @V_TAXABASECALC = (100 - @V_PREDBCTMP)/100;
            SET @V_TAXAALIQUOTA = (@V_ALIQUTMP/100);
            SET @V_TAXAALIQINFO = (@V_ALIQINFO/100);
            SET @V_TAXABCSUBSTR = 1 + (@V_PBCSUBTRIB/100);
            SET @V_BASECALCIT   = @V_LIQUIITEM * @V_TAXABASECALC;

            INSERT INTO TRABITPROIMPOS(
                  CDFILIMPOIT, NRLANCIMPOIT, NRSEQIMPOIT, CDIMPOSTOIT, CDFISCIMPOIT,
                  VRCONTIMPOIT, VRPDEDIMPOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRIMPOSIT,
                  VRBCALCIMPOIT, NRSEQITPRO)
            	 VALUES(
                     @V_NF_CDFILIAL, @V_NF_NRLANCTONF, @V_IT_NRSEQITPROD, @V_ID_CDIMPOTEMP, @V_ID_CDFISCTEMP,
                     @V_IT_VRTOTAITEM, 0, @V_ALIQUTMP, @V_PREDBCTMP, 0,
                     @V_IT_VRTOTAITEM, '1');

            DELETE ALIQTEMP
             WHERE NRALIQTEMP = @V_ALIQTEMP;
            FETCH NEXT FROM C_INCIDENCIA INTO  @V_ID_CDIMPOTEMP,   @V_ID_CDFISCTEMP,	  @V_ID_IDTRATIMPTMP,	@V_ID_IDCONSISTENT,
         	   										  @V_ID_IDUTMUNIORIG, @V_ID_IDIMPORECUP,	  @V_ID_IDPREIMPENTR,	@V_ID_IDORGARRECAD;

         END;
         CLOSE C_INCIDENCIA;
		   DEALLOCATE C_INCIDENCIA;

         DELETE INCITEMP
          WHERE NRINCITEMP = @V_INCITEMP;

         FETCH NEXT FROM C_ITEM INTO  @V_IT_CDARVPROD,   @V_IT_VRDESCITEM,   @V_IT_VRTOTAITEM,  @V_IT_NRSEQITPROD,
	   										  @V_IT_CDPRODUTO;
      END;
      CLOSE C_ITEM;
      DEALLOCATE C_ITEM;

      DECLARE C_IMPOSNFTOT CURSOR FOR SELECT IP.CDIMPOSTOIT AS CDIMPOSTO, SUM(ROUND(ISNULL(VRIMPOSIT,0),2)) AS VRIMPOSTOIT,
									                  ISNULL(SUM(VRBCALCIMPOIT),0) AS VRBASECALCIT
										          FROM TRABITPROIMPOS IP, IMPOSTO I
									            WHERE (IP.CDFILIMPOIT     = @V_NF_CDFILIAL)       AND
										               (IP.NRLANCIMPOIT    = @V_NF_NRLANCTONF)     AND
										               (I.CDIMPOSTO        = IP.CDIMPOSTOIT)
								            GROUP BY IP.CDIMPOSTOIT;

      OPEN C_IMPOSNFTOT;
   	FETCH NEXT FROM C_IMPOSNFTOT INTO  @V_INT_CDIMPOSTO,   @V_INT_VRIMPOSTOIT,   @V_INT_VRBASECALCIT;

	   WHILE (@@FETCH_STATUS = 0) BEGIN
      	DELETE FROM TRABIMPOSNFTOT
          WHERE CDFILIMPTOT   = @V_NF_CDFILIAL   AND
                NRLANCIMPTOT  = @V_NF_NRLANCTONF AND
                CDIMPOSTOT    = @V_INT_CDIMPOSTO;

 		   INSERT INTO TRABIMPOSNFTOT(
                CDFILIMPTOT,  NRLANCIMPTOT, CDIMPOSTOT,
                VRIMPOSTOT, VRBCALIMPTOT)
         VALUES (
                @V_NF_CDFILIAL, @V_NF_NRLANCTONF, @V_INT_CDIMPOSTO,
                ISNULL(@V_INT_VRIMPOSTOIT,0), ISNULL(@V_INT_VRBASECALCIT,0));

      	FETCH NEXT FROM C_IMPOSNFTOT INTO  @V_INT_CDIMPOSTO,   @V_INT_VRIMPOSTOIT,   @V_INT_VRBASECALCIT;
      END;
      CLOSE C_IMPOSNFTOT;
      DEALLOCATE C_IMPOSNFTOT;

      EXEC IMPOSTO_ENTRADA @V_NF_CDEMPRESA, @V_NF_CDINSCESTA, @V_NF_CDTIPOOPER, @V_NF_CDFORNECED, @V_NF_CDFILIAL,
      							@V_NF_NRLANCTONF, @V_NF_DTENTRSAID, @P_NRLANCESTQ,'E', NULL, NULL, @V_VRNOTAFISC OUTPUT;

      EXEC GRAVA_IMPOSTO @V_NF_CDFILIAL, @V_NF_NRLANCTONF;

      SET @P_VRNOTAFISC = @V_VRNOTAFISC;

      FETCH NEXT FROM C_NOTAIMP INTO  @V_NF_CDFILIAL,   @V_NF_NRLANCTONF,   @V_NF_CDEMPRESA,  @V_NF_CDINSCESTA,
   											  @V_NF_CDFORNECED, @V_NF_CDFILIRECE,   @V_NF_DTENTRSAID, @V_NF_CDSERIEENTR,
                  	                 @V_NF_NRINSJURNF, @V_NF_IDORIGDESTNF, @V_NF_CDTIPOOPER, @V_NF_CDFILIEMIT,
                     	              @V_NF_NRNOTAFISC;
   END;
   CLOSE C_NOTAIMP;
   DEALLOCATE C_NOTAIMP;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'SES_TRAB_IMPOSTO_ENTRADA','5.20.000';
GO
